package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.agraham.fft.FFT _fft = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
int _i = 0;
double[] _audio_real = null;
double[] _audio_imag = null;
double[] _audio = null;
double[] _fft_real = null;
double[] _fft_imag = null;
 //BA.debugLineNum = 26;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 28;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 30;BA.debugLine="Dim I As Int";
_i = 0;
 //BA.debugLineNum = 72;BA.debugLine="Dim AUDIO_REAL(1024) As Double";
_audio_real = new double[(int) (1024)];
;
 //BA.debugLineNum = 73;BA.debugLine="Dim AUDIO_IMAG(1024) As Double";
_audio_imag = new double[(int) (1024)];
;
 //BA.debugLineNum = 74;BA.debugLine="For I = 0 To 1023 Step 8";
{
final int step10 = (int) (8);
final int limit10 = (int) (1023);
for (_i = (int) (0); (step10 > 0 && _i <= limit10) || (step10 < 0 && _i >= limit10); _i = ((int)(0 + _i + step10))) {
 //BA.debugLineNum = 75;BA.debugLine="AUDIO_REAL(I + 0) = 76";
_audio_real[(int) (_i+0)] = 76;
 //BA.debugLineNum = 76;BA.debugLine="AUDIO_REAL(I + 1) = 23";
_audio_real[(int) (_i+1)] = 23;
 //BA.debugLineNum = 77;BA.debugLine="AUDIO_REAL(I + 2) = 2";
_audio_real[(int) (_i+2)] = 2;
 //BA.debugLineNum = 78;BA.debugLine="AUDIO_REAL(I + 3) = 56";
_audio_real[(int) (_i+3)] = 56;
 //BA.debugLineNum = 79;BA.debugLine="AUDIO_REAL(I + 4) = 8";
_audio_real[(int) (_i+4)] = 8;
 //BA.debugLineNum = 80;BA.debugLine="AUDIO_REAL(I + 5) = 75";
_audio_real[(int) (_i+5)] = 75;
 //BA.debugLineNum = 81;BA.debugLine="AUDIO_REAL(I + 6) = 2";
_audio_real[(int) (_i+6)] = 2;
 //BA.debugLineNum = 82;BA.debugLine="AUDIO_REAL(I + 7) = 44";
_audio_real[(int) (_i+7)] = 44;
 }
};
 //BA.debugLineNum = 84;BA.debugLine="FFT.Transform(AUDIO_REAL, AUDIO_IMAG)";
mostCurrent._fft.Transform(_audio_real,_audio_imag);
 //BA.debugLineNum = 85;BA.debugLine="FFT.Inverse(AUDIO_REAL, AUDIO_IMAG)";
mostCurrent._fft.Inverse(_audio_real,_audio_imag);
 //BA.debugLineNum = 86;BA.debugLine="Log(\"With Transform and Inverse\")";
anywheresoftware.b4a.keywords.Common.Log("With Transform and Inverse");
 //BA.debugLineNum = 87;BA.debugLine="For I = 0 To 1023";
{
final int step23 = 1;
final int limit23 = (int) (1023);
for (_i = (int) (0); (step23 > 0 && _i <= limit23) || (step23 < 0 && _i >= limit23); _i = ((int)(0 + _i + step23))) {
 //BA.debugLineNum = 88;BA.debugLine="Log(AUDIO_REAL(I))  'Data is the same as it went in";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_audio_real[_i]));
 }
};
 //BA.debugLineNum = 93;BA.debugLine="Dim AUDIO(1024) As Double";
_audio = new double[(int) (1024)];
;
 //BA.debugLineNum = 94;BA.debugLine="Dim FFT_REAL(512) As Double";
_fft_real = new double[(int) (512)];
;
 //BA.debugLineNum = 95;BA.debugLine="Dim FFT_IMAG(512) As Double";
_fft_imag = new double[(int) (512)];
;
 //BA.debugLineNum = 96;BA.debugLine="For I = 0 To 1023 Step 8";
{
final int step29 = (int) (8);
final int limit29 = (int) (1023);
for (_i = (int) (0); (step29 > 0 && _i <= limit29) || (step29 < 0 && _i >= limit29); _i = ((int)(0 + _i + step29))) {
 //BA.debugLineNum = 97;BA.debugLine="AUDIO(I + 0) = 76";
_audio[(int) (_i+0)] = 76;
 //BA.debugLineNum = 98;BA.debugLine="AUDIO(I + 1) = 23";
_audio[(int) (_i+1)] = 23;
 //BA.debugLineNum = 99;BA.debugLine="AUDIO(I + 2) = 2";
_audio[(int) (_i+2)] = 2;
 //BA.debugLineNum = 100;BA.debugLine="AUDIO(I + 3) = 56";
_audio[(int) (_i+3)] = 56;
 //BA.debugLineNum = 101;BA.debugLine="AUDIO(I + 4) = 8";
_audio[(int) (_i+4)] = 8;
 //BA.debugLineNum = 102;BA.debugLine="AUDIO(I + 5) = 75";
_audio[(int) (_i+5)] = 75;
 //BA.debugLineNum = 103;BA.debugLine="AUDIO(I + 6) = 2";
_audio[(int) (_i+6)] = 2;
 //BA.debugLineNum = 104;BA.debugLine="AUDIO(I + 7) = 44";
_audio[(int) (_i+7)] = 44;
 }
};
 //BA.debugLineNum = 106;BA.debugLine="FFT.Transform2(AUDIO, FFT_REAL, FFT_IMAG)";
mostCurrent._fft.Transform2(_audio,_fft_real,_fft_imag);
 //BA.debugLineNum = 107;BA.debugLine="FFT.Inverse2(FFT_REAL, FFT_IMAG, AUDIO)";
mostCurrent._fft.Inverse2(_fft_real,_fft_imag,_audio);
 //BA.debugLineNum = 108;BA.debugLine="Log(\"With Transform2 and Inverse2\")";
anywheresoftware.b4a.keywords.Common.Log("With Transform2 and Inverse2");
 //BA.debugLineNum = 109;BA.debugLine="For I = 0 To 1023";
{
final int step42 = 1;
final int limit42 = (int) (1023);
for (_i = (int) (0); (step42 > 0 && _i <= limit42) || (step42 < 0 && _i >= limit42); _i = ((int)(0 + _i + step42))) {
 //BA.debugLineNum = 110;BA.debugLine="Log(AUDIO(I))  'Data is different than it went in";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_audio[_i]));
 }
};
 //BA.debugLineNum = 113;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 118;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 120;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 115;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 117;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 23;BA.debugLine="Dim FFT As FFT";
mostCurrent._fft = new anywheresoftware.b4a.agraham.fft.FFT();
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
}
